/* -*- c -*-
 * Time-stamp: <2005-04-20 22:31:53 rsmith>
 * 
 * onepad/padfile.h
 * Copyright (C) 2001--2005 R.F. Smith <rsmith@xs4all.nl>. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _PADFILE_H
#define _PADFILE_H

#ifdef __cplusplus
extern "C" {
#pragma }			/* to stop Emacs indenting it wrong */
#endif				/* __cplusplus */

/**
 * struct padfile - for handling onepad key- and encrypted files
 * @f: the file
 * @id: identifier string
 * @read: 1 if opened for reading, 0 for writing
 * @col: current column number if writing a file
 * @line: current line number if writing a file
 * 
 **/
struct padfile {
	FILE *f;
	int read;
	int col;
	int ln;
	char id[64];
};

struct padfile *pfopenr(const char *name);
struct padfile *pfopenw(const char *name, const char *id);
int pfreadb(struct padfile *pf, unsigned char *pb);
int pfwriteb(struct padfile *pf, unsigned char b);
int pfclose(struct padfile *pf);

#ifdef __cplusplus
}
#endif				/* __cplusplus */
#endif				/* _PADFILE_H */
/* EOF padfile.h */
